// Globals.h

#ifndef GLOBAL_VARIABLES_H
#define GLOBAGS_VARIABLES_H

#include <vector>

class Voxel;
class Triangle;

extern bool drawVoxelsEnabled;
extern short GRID_SIZE;
extern int NUM_VOXELS;
extern std::vector<std::vector<std::vector<Voxel*> > > voxels;
extern std::vector<std::vector<std::vector<Voxel*> > > sec_voxels;
extern std::vector<Triangle*> mesh;
extern bool secVoxelsExist;
extern std::vector<Voxel*> renderVoxels;
extern std::vector<std::vector<short> > renderVoxelsIndex;
extern const unsigned short UNLABELED;
extern const unsigned short NOISE;
extern const unsigned short SSL_ELEM;

#endif // GLOBALS_H