// Input.h

#ifndef INPUT_H_
#define INPUT_H_

#include <string>
#include <vector>

using std::string;
using std::vector;

class Input {

public:
  Input();
  ~Input();

  static void processVXS(short threshold);
  static void processPPM(string filename);

private:
  static vector<string>& split(const string& s, char delim, vector<string>& elems);
  static const char delim_char;
};

#endif // INPUT_H_