// MarchingCubes.h

#ifndef MARCHING_CUBES_H
#define MARCHING_CUBES_H

#include "Globals.h"
#include <iostream>
#include <vector>

using std::cout;
using std::vector;

class Voxel;

class MarchingCubes
{
public:
  MarchingCubes();
  ~MarchingCubes();

  static void marchingCubes();

private:
  static vector<float> getMarchingCubePoint(short pNum, short& x, short& y, short& z);
  static void addMeshTriangle(short pt1, short pt2, short pt3, short& x, short& y, short& z);
  static bool cubeState0(short& x, short& y, short& z);
  static bool cubeState1(short& x, short& y, short& z);
  static bool cubeState2(short& x, short& y, short& z);
  static bool cubeState3(short& x, short& y, short& z);
  static bool cubeState4(short& x, short& y, short& z);
  static bool cubeState5(short& x, short& y, short& z);
  static bool cubeState6(short& x, short& y, short& z);
  static bool cubeState7(short& x, short& y, short& z);
  static bool cubeState8(short& x, short& y, short& z);
  static bool cubeState9(short& x, short& y, short& z);
  static bool cubeState10(short& x, short& y, short& z);
  static bool cubeState11(short& x, short& y, short& z);
  static bool cubeState12(short& x, short& y, short& z);
  static bool cubeState13(short& x, short& y, short& z);
  static bool cubeState14(short& x, short& y, short& z);
  static bool cubeState15(short& x, short& y, short& z);
  static bool cubeState16(short& x, short& y, short& z);
  static bool cubeState17(short& x, short& y, short& z);
  static bool cubeState18(short& x, short& y, short& z);
  static bool cubeState19(short& x, short& y, short& z);
  static bool cubeState20(short& x, short& y, short& z);
  static bool cubeState21(short& x, short& y, short& z);
  static bool cubeState22(short& x, short& y, short& z);
  static bool cubeState23(short& x, short& y, short& z);
  static bool cubeState24(short& x, short& y, short& z);
  static bool cubeState25(short& x, short& y, short& z);
  static bool cubeState26(short& x, short& y, short& z);
  static bool cubeState27(short& x, short& y, short& z);
  static bool cubeState28(short& x, short& y, short& z);
  static bool cubeState29(short& x, short& y, short& z);
  static bool cubeState30(short& x, short& y, short& z);
  static bool cubeState31(short& x, short& y, short& z);
  static bool cubeState32(short& x, short& y, short& z);
  static bool cubeState33(short& x, short& y, short& z);
  static bool cubeState34(short& x, short& y, short& z);
  static bool cubeState35(short& x, short& y, short& z);
  static bool cubeState36(short& x, short& y, short& z);
  static bool cubeState36_b(short& x, short& y, short& z);
  static bool cubeState37(short& x, short& y, short& z);
  static bool cubeState38(short& x, short& y, short& z);
  static bool cubeState39(short& x, short& y, short& z);
  static bool cubeState39_b(short& x, short& y, short& z);
  static bool cubeState40(short& x, short& y, short& z);
  static bool cubeState41(short& x, short& y, short& z);
  static bool cubeState42(short& x, short& y, short& z);
  static bool cubeState42_b(short& x, short& y, short& z);
  static bool cubeState43(short& x, short& y, short& z);
  static bool cubeState44(short& x, short& y, short& z);
  static bool cubeState45(short& x, short& y, short& z);
  static bool cubeState45_b(short& x, short& y, short& z);
  static bool cubeState46(short& x, short& y, short& z);
  static bool cubeState47(short& x, short& y, short& z);
  static bool cubeState48(short& x, short& y, short& z);
  static bool cubeState48_b(short& x, short& y, short& z);
  static bool cubeState49(short& x, short& y, short& z);
  static bool cubeState50(short& x, short& y, short& z);
  static bool cubeState50_b(short& x, short& y, short& z);
  static bool cubeState51(short& x, short& y, short& z);
  static bool cubeState52(short& x, short& y, short& z);
  static bool cubeState53(short& x, short& y, short& z);
  static bool cubeState54(short& x, short& y, short& z);
  static bool cubeState55(short& x, short& y, short& z);
  static bool cubeState56(short& x, short& y, short& z);
  static bool cubeStateFull(short& x, short& y, short& z);

};


#endif // MARCHING_CUBES_H
