/*
 *  SSLElem.h
 *  voxvis
 *
 *  Created by Erlend Andreas Lorentzen on 5/22/11.
 *  Copyright 2011 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef SSLELEM_H
#define SSLELEM_H

class SSLElem
{
public:
  SSLElem(short x, short y, short z, float delta) {
    xVal = x;
    yVal = y;
    zVal = z;
    deltaVal = delta;
  }
  
  short x() const {return xVal;}
  short y() const {return yVal;}
  short z() const {return zVal;}
  float delta() const {return deltaVal;}
  
private:
  short xVal;
  short yVal;
  short zVal;
  float deltaVal;
};

inline bool operator< (const SSLElem& e1, const SSLElem& e2)
{
  return e1.delta() < e2.delta();
}

#endif //SSLELEM_H